<?php 

// if i believed in name spacing in php, i'd use it.
error_log("glcasweb loaded");

class GLCASWeb {
	
	function __construct($config)
	{
		$this->config = $config;
	}
	
	function go($urlhandlers)
	{
		$url = "/";
		if(isset($_REQUEST["q"])) {
			$url = $_REQUEST["q"];
		}
		
		// create a url parser
		$urlparser = new GLCASUrlParser($urlhandlers, $this->config);
		
		// 
		$call_class = $urlparser->getClass($url);
		error_log("urldecode: ".urldecode($url));
		$call_class->go($url);
	}
	
	private $config;
	
}

function GLCASMenuBuilder()
{
	global $BASE_URL;
	?>
<a href="<?php echo $BASE_URL ?>">Home</a>
<a href="<?php echo $BASE_URL."/admin/"?>">Admin</a>
	<?php
}

function GLCASMessageBuilder()
{
	echo "<i>Messages not implemented yet</i>";
}

function GLCASpageBuilder($bodyClass, $bodyFunction, $bodycontent, $title="GLCAS")
{
	global $WEB_ROOT_FS, $BASE_URL;
	
	// TODO: load css
	// header
	echo "<html><head><title>$title</title>";
	
	// load css
	if(file_exists("$WEB_ROOT_FS/css")) {
		$dh = opendir("$WEB_ROOT_FS/css");
		if($dh) {
			while(($file = readdir($dh))!==false) {
				$mt = preg_match("/.*.css$/", $file);
				if($mt > 0) {
					error_log("loading css $file");
					echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"$BASE_URL/css/$file\">";
					//echo "required $basedir/$file\n";
				}
			}
		}		
	}

	// load js
	if(file_exists("$WEB_ROOT_FS/js")) {
		$dh = opendir("$WEB_ROOT_FS/js");
		if($dh) {
			while(($file = readdir($dh))!==false) {
				$mt = preg_match("/.*.js$/", $file);
				if($mt > 0) {
					error_log("loading js $file");
					echo "<script type=\"text/javascript\" src=\"$BASE_URL/css/$file\"></script>";
					//echo "required $basedir/$file\n";
				}
			}
		}		
	}
	
	
	// start body
	echo "</head><body>";
	
	// page top
	echo "<h1>GLCAS</h1><br>";
	echo "<table><tr><td>";
	GLCASMessageBuilder();
	echo "<td></tr><tr><td>";
	
	// menu, then body
	echo "<table><tr><td>";
	GLCASMenuBuilder();
	echo "</td></tr><tr><td>";
	// body
	$url = "/";
	if(isset($_REQUEST["q"])) {
		$url = $_REQUEST["q"];
	}
	
	if($bodyClass != null) {
		$bodyClass->$bodyFunction($url);
	} else if( $bodyFunction != null) {
		$bodyFunction($url);
	} else echo $bodycontent;
	echo "</td></tr></table>";
	
	
	// close the big wrap-around table
	echo "</td></tr></table>";
	
	// footer
	echo "<br><font size=\"-1\">Copyright 2011, PJR</font><br></body></html>";
	
}


?>