<?php 

error_log("admin loaded");

global $URL_HANDLERS;
$URL_HANDLERS["admin.*"] = "GLCASAdmin";

class GLCASAdmin {
	function __construct($config)
	{
		$this->config = $config;
		error_log("constructor for GLCASAdmin");
		
	}
	
	function go($url)
	{
		error_log("repo:go called");
		
		if(isset($_REQUEST["action"])) {
			switch($_REQUEST["action"]) {
				case "updaterepo":
					error_log("in updaterepo");
					GLCASpageBuilder($this,"doUpdateRepo");
					return;
				case "reponext":
					error_log("in reponext");
					GLCASpageBuilder($this,"doRepoNextForm");
					return;
					break;
				case "addrepoyum":
					GLCASpageBuilder($this,"doAddRepoYum");
					return;
				case "deleterepo":
					error_log("call delete repo");
					GLCASpageBuilder($this, "doRemoveRepo");
					return;
				case "setstorage":
					error_log("call setstorage");
					GLCASpageBuilder($this, "setStorage");
					return;
				case "scanrepo":
					break;
			}
		}
		GLCASpageBuilder($this, "body");
	}
	
	function body($url)
	{
		// for the main admin body, we hae the following components
		
		// 1. list of currently available repos and stuff
		
		// 2. way to add a repo direct
		
		// 3. way to scan for a repo given a url
		
		// so first, lets do the main body
		$this->mainBody($url);
	}
	
	function doRemoveRepo($url)
	{
		$repo = $_REQUEST["repo"];
		$myRep = new GLCASRepo($this->config);
		
		
		error_log("called delete repo on $repo");
		$myRep->deleteRepo($repo);
		
		global $WEB_ROOT_FS, $URL_HANDLERS, $BASE_URL;
		header("Location: $BASE_URL/admin/");
	}
	
	
	function setStorage($url)
	{
		
	}
	
	function doRepoNextForm($url)
	{
		$myRep = new GLCASRepo($this->config);
		
		$wasyum = false;
		if($_REQUEST["repotype"] == "yumbase") {
			$glt = $myRep->getRepoDetailsYum($_REQUEST["repourl"]);
			$wasyum = true;
		} else if($_REQUEST["repotype"] == "yummirrorlist") {
			$glt = $myRep->getRepoDetailsYum($_REQUEST["repourl"], true);
			$wasyum = true;
		} else if($_REQUEST["repotype"] == "apt") {
			$glt = $myRep->getRepoDetailsApt($_REQUEST["repourl"]);
		}
		
		
		if($wasyum) {
			$os = $glt["OS"];
			$version = $glt["version"];
			$arch = $glt["arch"];
			$other = $glt["other"];
			$repourl = $_REQUEST["repourl"];
			echo "<form method=\"post\" action=\"?action=addrepoyum\">";
			echo "<input type=\"hidden\" name=\"repourl\" value=\"$repourl\">";
			echo "<table>";
			echo "<tr><td>Description</td><td><input type=\"text\" name=\"desc\" value=\"$os, $version, $arch - $other\"></td></tr>";
			echo "<tr><td>OS</td><td><input type=\"text\" name=\"OS\" value=\"$os\"></td></tr>";
			echo "<tr><td>Version</td><td><input type=\"text\" name=\"version\" value=\"$version\"></td></tr>";
			echo "<tr><td>Architecture</td><td><input type=\"text\" name=\"arch\" value=\"$arch\"></td></tr>";
			echo "<tr><td>Other (OS, Updates, etc)</td><td><input type=\"text\" name=\"other\" value=\"$other\"></td></tr>";
			echo "<tr><td>Short URL</td><td><input type=\"text\" name=\"shorturl\"></td></tr>";
			echo "<tr><td>URL Prefix (blank for none)</td><td><input type=\"text\" name=\"prefix\"></td></tr>";
			echo "<tr><td>Do Initial Update (can take a while)</td><td><input type=\"checkbox\" name=\"initial\" checked></td></tr>";
			echo "<tr><td><input type=\"submit\" name=\"Add\" value=\"Add\"></td></tr>";
			echo "</table>";
			echo "</form>";
		} else {
			// apt is much tricker cause one repo can provide multiple versions, OS's and architectures.
		}
	}
	
	function doAddRepoYum($url)
	{
		$repo = new GLCASRepo($this->config);
		
		$desc = $_REQUEST["desc"];
		$OS = $_REQUEST["OS"];
		$version = $_REQUEST["version"];
		$arch = $_REQUEST["arch"];
		$other = $_REQUEST["other"];
		$shorturl = $_REQUEST["shorturl"];
		$prefix = $_REQUEST["prefix"];
		$repurl = $_REQUEST["repourl"];
		$init = false;
		if(isset($_REQUEST["initial"])) $init = true;
		
		
		
		$repo->addRepo($desc, $OS, $version, $arch, $other, $shorturl, $prefix, $repurl, "YUM", $init);
		
		global $WEB_ROOT_FS, $URL_HANDLERS, $BASE_URL;
		header("Location: $BASE_URL/admin/");
	}
	
	function doUpdateRepo($url)
	{
		$rkey = $_REQUEST["repo"];
		
		$repo = new GLCASRepo($this->config);
		
		$repo->updateRepo($rkey);
		global $WEB_ROOT_FS, $URL_HANDLERS, $BASE_URL;
		header("Location: $BASE_URL/admin/");
	}
	
	function mainBody($url)
	{
		global $WEB_ROOT_FS, $URL_HANDLERS, $BASE_URL;
		
		// first, list available repos
		echo "<h3>Repositories</h3>";
		echo "<br><table border=\"1\">";
		echo "<tr><th>Name</th><th>Type</th><th>OS</th><th>Version</th><th>Architecture</th><th>Other</th><th>Prefix</th><th>Short URL</th><th>Browse</th><th>Control</th></tr>";
		
		// now iterate thru the repos and print them
		$repo = new GLCASRepo($this->config);
		$repos = $repo->getRepos();
		
		foreach($repos as $rkey => $rval) {
			$desc = $rval["desc"];
			$os = $rval["os"];
			$version = $rval["version"];
			$arch = $rval["arch"];
			$other = $rval["other"];
			$repotype = $rval["repotype"];
			$prefix = $rval["prefix"];
			$shorturl = $rval["shorturl"];
			if($prefix == "") $prefix = "-";
			if($shorturl == "") $shorturl = "-";
			echo "<tr><td>$desc</td><td>$repotype</td><td>$os</td><td>$version</td><td>$arch</td><td>$other</td><td>$prefix</td><td>$shorturl</td>";
			
			// get url
			$browseurl = "$BASE_URL/repo/$rkey";
			if($shorturl!="-") {
				$brurl = $shorturl;
				if($prefix != "-") $brurl = "$prefix/$shorturl";
				$browseurl = "$BASE_URL/$brurl/";
			}
			
			echo "<td><a href=\"$browseurl\">Browse</td><td>";
			
			// Edit
			echo "<a href=\"?action=editrepo&repo=$rkey\">Edit</a> ";
			// update
			echo "<a href=\"?action=updaterepo&repo=$rkey\">Update</a> ";
			// freeze
			echo "<a href=\"?action=freezerepo&repo=$rkey\">Freeze</a> ";
			// deactivate
			echo "<a href=\"?action=disablerepo&repo=$rkey\">Disable</a> ";
			// clean
			echo "<a href=\"?action=cleanrepo&repo=$rkey\">Clean</a> ";
			// Remove
			echo "<a href=\"?action=deleterepo&repo=$rkey\">Delete</a>";
			
			echo "</td>";
			echo "</tr>";
		}
		
		echo "</table><br><hr>";
		//echo "<pre>";
		//if($repos !== false) print_r($repos);
		//echo "</pre>";
		
		// wrap all this in a table
		echo "<table><tr><td valign=\"top\">";
		// now, add a repo
		echo "<h3>Add A Repo</h3>";
		echo "<form method=\"post\" action=\"?action=reponext\">";
		echo "Type <select name=\"repotype\">";
			echo "<option value=\"yumbase\">YUM (Base URL)</option>";
			echo "<option value=\"yummirrorlist\">YUM (Mirror List) - not implemented</option>";
			echo "<option value=\"apt\">APT - not implemented</option>";
			echo "</select><br>";
		echo "URL <input type=\"text\" name=\"repourl\"><br>";
		echo "<input type=\"submit\" name=\"Add\" value=\"Add\"><br>";
		echo "</form>";
		
		echo "</td><td valign=\"top\">";
		
		// now scan for a repo
		echo "<h3>Scan For Repos - not implemented</h3>";
		echo "<form method=\"post\" action=\"?action=scanrepo\">";
		echo "Hint <select name=\"repohint\">";
			echo "<option value=\"fedora\">Fedora</option>";
			echo "<option value=\"centos\">Centos</option>";
			echo "<option value=\"ubuntu\">Ubuntu</option>";
			echo "</select><br>";
		echo "URL <input type=\"text\" name=\"repourl\"><br>";
		echo "<input type=\"submit\" name=\"Scan\" value=\"Scan\"><br>";
		echo "</form>";
		
		echo "</td></tr></table><hr>";
		
		// repo storage location
		echo "<h3>Storage<h3><br>";
		echo "<form method=\"post\" action=\"?action=setstorage\">";
		$storloc = $this->config->getConfigVar("storagelocation");
		echo "<input type=\"text\" name=\"storageloc\" value=\"$storloc\" size=\"100\">";
		echo "<input type=\"submit\" name=\"Set\" value=\"Set\">";
		echo "</form>";
	}

	private $config;
}

?>